version: 3

tasks:

  cluster:create:
    cmds:
    - k3d cluster create t2m -p 80:80@loadbalancer -p 443:443@loadbalancer

  cluster:install:
    dir: $GHQ_ROOT/gitlab.com/davinkevin.fr/home-server/
    cmds:
      - kustomize build mastodon-t2m/overlays/local --load-restrictor=LoadRestrictionsNone | kubectl apply -f -

  build:bird.makeup:
    dir: $GHQ_ROOT/gitlab.com/davinkevin.fr/projects/dotmakeup
    cmds:
      - docker build bird.makeup -t davinkevin/bird.makeup:latest

  build:social-sidecar:
    dir: $GHQ_ROOT/gitlab.com/davinkevin.fr/projects/dotmakeup
    cmds:
      - docker build social-sidecar -t davinkevin/social-sidecar:latest

  import:bird.makeup:
    deps:
      - task: build:bird.makeup
    cmds:
      - k3d image import davinkevin/bird.makeup:latest --cluster t2m

  import:social-sidecar:
    deps:
      - task: build:social-sidecar
    cmds:
      - k3d image import davinkevin/social-sidecar:latest --cluster t2m

  cluster:publish:
    deps:
      - task: cluster:install
    cmds:
      - task: import:bird.makeup
      - task: import:social-sidecar
      - task: cluster:restart

  cluster:restart: kubectl rollout restart deploy/birdsite deploy/social-sidecar -n mastodon-t2m

  cluster:copy-prod-db:
    silent: true
    cmd: |-
      cd $(mktemp -d)
      export KUBECONFIG=~/.kube/k8s-server.yaml
      podname=$(kubectl get pods -n mastodon-t2m -l app.kubernetes.io/name=social-sidecar -o name | sd 'pod/' '')
      kubectl -n mastodon-t2m cp $podname:/twscrape/accounts.db accounts.db > /dev/null
      
      export KUBECONFIG=""
      podname=$(kubectl get pods -n mastodon-t2m -l app.kubernetes.io/name=social-sidecar -o name | sd 'pod/' '')
      kubectl -n mastodon-t2m cp accounts.db $podname:/twscrape/accounts.db > /dev/null
      
      echo "Done"
      kubectl -n mastodon-t2m exec svc/social-sidecar -- twscrape --db /twscrape/accounts.db accounts

  cluster:expose:
    cmds:
      - ngrok http 80